import gtk
import common
import numpy as np
import time
import struct
import socket
import copy
import pickle

def flip(arr):
    r, c = arr.shape
    inv1 = -np.arange(r)-1
    inv2 = -np.arange(c)-1
    res = np.take(arr, inv2, axis = 1)
    return np.take(res, inv1, axis = 0)

class sMessage:
    def __init__(self):
    	self.typ = 0
	self.length = 0
	self.data = ''
    

class IRCamSocket:
    def __init__(self):
        """ constructor, setting initial variables """
        self._sleepperiod = 0.4
	self.smessage = sMessage()
        self.host = common.host
        self.port = common.port
##        print "self.host = ", self.host
##        print "self.port = ", self.port

    def initSocket(self):
        self.sock = None
        self.host = common.host
        self.port = common.port        
        for res in socket.getaddrinfo(self.host, self.port, socket.AF_UNSPEC, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
            print 'could not open socket'

    def readFrame(self):
        self.smessage.length = common.rows * common.cols * 4
        common.dataArray = np.zeros((common.rows, common.cols), dtype = np.float32)
        #read frame
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockFrame = 0
        else:
            self.flagSockFrame = 1
            self.sock.settimeout(30)
            self.sock.send('RD')
            self.sock.send(struct.pack('L', self.smessage.length))
##            print "sent data"
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            common.dataArray = np.fromstring(data, dtype=np.float32)
            common.dataArray.shape = (common.rows, common.cols)
            common.dataArray = common.dataArray*self.mask()

    def mask(self):
        img = np.ones((256, 256))
        
        i =[  1,  26,  28,  41,  41,  54,  67,  67,  82,  87, 100, 104, 142,\
              143, 143, 147, 165, 175, 182, 183, 189, 193, 210, 233, 236]
        j = [ 62, 235, 186,  35, 167, 141,  33,  79,  99, 166, 211,  23, 163,\
              162, 163,  94, 118, 153, 205, 245, 193,  71,  73, 194, 238]
        img[i,j] = 0
        tmp = np.zeros((common.rows, common.cols))
        tmp[ 0:common.rows/2, 0:common.cols/2,] =\
                             img[128-common.rowOffset-common.rows/2:128-common.rowOffset,\
                                 common.colOffset:common.colOffset+common.cols/2]
        tmp[0:common.rows/2, common.cols/2:common.cols] =\
                             img[128-common.rowOffset-common.rows/2:128-common.rowOffset, \
                                 128+common.colOffset:128+common.colOffset+common.cols/2]
        tmp[common.rows/2:common.rows, 0:common.cols/2] =\
                             img[256-common.rowOffset-common.rows/2:256-common.rowOffset, \
                                common.colOffset:common.colOffset+common.cols/2]        
        tmp[common.rows/2:common.rows, common.cols/2:common.cols] =\
                             img[256-common.rowOffset-common.rows/2:256-common.rowOffset, \
                                 128+common.colOffset:128+common.colOffset+common.cols/2]
        return tmp
        
