#common.py:
import numpy as np

host  = '192.168.3.136'
port = 60000

import controlMountSocket

#luminos and zaber serial com info
nport = '192.168.3.137'
zaberPort =  4005
zaberNAxis = 1
zab = controlMountSocket.mountControl(zaberPort, zaberNAxis)


## rmg/fb alignment stuff ######################################################################

# this will be replaced by obtaining the number of beams from champ server
# see ../FTGui/IRCamCommands.py: data = self.getStructFromRT('SP',cstruct)
number_beams = 6

#####################
## config for 4 beams
#####################

# aligment steps
step_4 = [1,2,3,4,5,6,7,8,9,10,11,12]

# active beam
beam_4 = [1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4]

# spot name
spot_name_4 =  ['L1', 'R2', 'L2', 'R3', 'R2', 'L3', 'R4', 'R3', 'L4', 'R1', 'R4', 'L1']

# spot quadrant
spot_quadrant_4 = [2, 1, 4, 1, 1, 1, 4, 1, 3, 3, 4, 2]

# position within the quadrant
position_index_4 = [1, 2, 1, 4, 2, 1, 4, 4, 1, 4, 4, 1]   
position_name_4 = ['Bottom Left', 'Bottom Right', 'Top Left', 'Top Right']

# pico name
pico_name_4 = ['Dicroic 1 (or T3H)', 'T2H', 'Dicroic 2 (or T3M)', 'T2M','BC1-2','Dicroic 3 (or T4H)','T1L','BC2-3','Dicroic 4 (T4M)','T2L','BC3-4','BC6-1']

#corresponding pico numbers
pico_allowed_4 = [18, 3, 19, 4, 13, 20, 2, 14, 21, 5, 15, 12]

# comment
additional_info_4 = ['Nothing', 'top spot','top spot', 'bottom spot','top spot','bottom spot','top spot','bottom spot','top spot','top spot','top spot','bottom spot']

# x and y coordinates of target spot location
xtarget_4 = [1,6,1,6,6,1,6,6,1,6,6,1]
ytarget_4 = [1,1,1,6,1,1,6,6,1,6,6,1]

# automatic selection of proper spot in channel flux display
# order in channel selection is "L1","R1","L2","R2","L3","R3","L4","R4","L5","R5","L6","R6"
#                               0     1    2    3    4    5    6    7    8    9    10   11
spot_number_4 = [0, 3, 2, 5, 3, 4, 7, 5, 6, 1, 7, 0]

#####################
## config for 6 beams
#####################

# aligment steps
step_6 = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18]

# active beam
beam_6 = [1,1,2,2,2,3,3,3,4,4,4,5,5,5,6,6,6,6]

# spot name
spot_name_6 =  ['L1','R2','L2','R3','R2','L3','R4','R3','L4','R5','R4','L5','R6','R5','L6','R1','R6','L1']

# spot quadrant
spot_quadrant_6 = [2,1,4,1,1,1,4,1,3,2,4,3,2,2,4,3,2,2]

# position within the quadrant
position_index_6 = [1,2,1,4,2,1,4,4,1,2,4,3,4,2,3,4,4,1]   
position_name_6 = ['Bottom Left', 'Bottom Right', 'Top Left', 'Top Right']

# pico name
pico_name_6 = ['Dicroic 1 (or T3H)', 'T2H', 'Dicroic 2 (or T3M)', 'T2M','BC1-2','Dicroic 3 (or T4H)','T1L','BC2-3','Dicroic 4 (T4M)','T1H','BC3-4','Dichroic 5','T1M','BC4-5','Dichroic 6','T2L','BC5-6','BC6-1']

pico_allowed_6 = [18, 3, 19, 4, 13, 20, 2, 14, 21, 0, 15, 22, 1, 16, 23, 5, 17, 12]
#pico_also_allowed_6

# comment
additional_info_6 = ['top spot','top spot','top spot','bottom spot','top  spot','bottom  spot','top  spot','bottom  spot','top  spot','bottom  spot','top  spot','top spot (may be faint)','should be clean','bottom  spot','should be clean','top  spot','should be clean','???']

# x and y coordinates of target spot location
xtarget_6 = [1,6,1,6,6,1,6,6,1,6,6,1,6,6,1,6,6,1]
ytarget_6 = [1,1,1,6,1,1,6,6,1,1,6,6,6,1,6,6,6,1]

# automatic selection of proper spot in channel flux display
# order in channel selection is "L1","R1","L2","R2","L3","R3","L4","R4","L5","R5","L6","R6"
#                               0     1    2    3    4    5    6    7    8    9    10   11
spot_number_6 = [0, 3, 2, 5, 3, 4, 7, 5, 6, 9, 7, 8, 11, 9, 10, 1, 11, 0]

# shutter index (shutter.cfg from TtB) - obsolete
# shutter_index = [3,3,4,4,4,5,5,5,6,6,6,6]


# position marker (green cross) for the automatic alignment
xmove = 3
ymove = 3
peakval = 0.

plus_scales = range(48)
minus_scales = range(48)
angle_scales = range(48)

def_plus_scales = range(48)
def_minus_scales = range(48)
def_angle_scales = range(48)


#mode definition
#FB May 2012 changed defaults to 0 
autoalignfind = 0
calib = 0
spiral = 0 

widefieldmode = 0 # tracks whether we are in wide field or not

# Mode labels
rate = [250,500,1000]
stroke = [30, 50, 70]



## end alignment stuff ######################################################################
status1 = 9
status2 = 9

# makes sure these faults match the defaults in ircam commands or there will be
# mismatch between values!
rows = 16
cols = 16
roff = 8 #5   #7
coff = 20 #20  #9

framesPerReset=21
numberOfFrames=42

dataready1 = 0
dataready2 = 0
myArray = np.zeros((rows, cols), dtype=np.float32)
myArrayQuadrant = np.zeros((rows/2, cols/2), dtype=np.float32)
myArrayQuadrantframes = 0
fluxArray = np.zeros((12,numberOfFrames), dtype=np.float32)
psArray = np.zeros((rows/2, 1+cols/2), dtype=np.float32)
fmArray = np.zeros((6,6), dtype=np.float32)
#fm peaks: 4 quads (UR,UL,BL,BR), x,y,peak,Fraction in peak,total counts
fmPeaks = np.zeros((4,5), dtype=np.float32)

fmFluxArray = np.zeros((100,4),dtype=np.float32)

gdtInfo = np.zeros(7, dtype=np.uint32)
delayLinesOffsets = np.zeros(6, dtype=np.float64)
updatedOffsets = np.zeros(6, dtype=np.float64)
weights = np.zeros(6, dtype=np.float32)
opds  = np.zeros(6, dtype=np.float32)

#calibration gui
stepsS = 0.
stepsT = 0.

#shutter control -- defines whether the gui should control the shutters directly
shuttercontrol  = 0


# here i could also do initialization of align GUI for 4 or 6 beams,
# by setting the appropriate variables to the values for 4 or 6 beams in common.py
if number_beams == 4:
    step = step_4
    beam = beam_4
    spot_name = spot_name_4
    spot_quadrant = spot_quadrant_4
    position_index = position_index_4
    position_name = position_name_4
    pico_name = pico_name_4
    pico_allowed = pico_allowed_4
    additional_info = additional_info_4
    xtarget = xtarget_4
    ytarget = ytarget_4
    spot_number = spot_number_4

if number_beams == 6:
    step = step_6
    beam = beam_6
    spot_name = spot_name_6
    spot_quadrant = spot_quadrant_6
    position_index = position_index_6
    position_name = position_name_6
    pico_name = pico_name_6
    pico_allowed = pico_allowed_6
    additional_info = additional_info_6
    xtarget = xtarget_6
    ytarget = ytarget_6
    spot_number = spot_number_6
