#common.py:
import numpy as np

host  = '192.168.3.136'
port = 60000
timeout = 2

#Matrix to convert channelNr into FringeNr
#                        L1R1, L2R2, L3R3, L4R4, L5R5, L6R6
#                                   FR4  FR1
chNrL2Fringe = np.array([0,    2,    4,    6,    8,   10])
chNrR2Fringe = np.array([1,    3,    5,    7,    9,   11])


nBL = 6

numberOfFrames = 108   #(number of flux measurements within one scan)
MAXCOMBOS = 12        #(12 channels for 6 baselines)
FTMEMORY = 60        #(History size)

liveDisplayStatus = 0
activeFringe = np.array([1,1,1,1,1,1])
nbFringe = nBL   #adjust this number
plotType = np.array([0,0,0,0])
intPlotA = 1
intPlotB = 1
intPlotC = 1
intPlotD = 1

plotEMPTY = 0
plotFLUXvsOPD = 1
plotAMPvsOPD = 2
plotFLUXvsT = 3
plotPHIvsT = 4
plotDELAYvsT = 5
plotFTOFFSETSvsT = 6
plotFTSTATEvsT = 7
plotFTNUMvsFTOFFSETS = 8
plotPHIvsOPD = 9
plotFTNUMvsT = 10

dataReadyFLUXvsOPD = 0
dataReadyAMPvsOPD = 0
dataReadyFLUXvsT = 0
dataReadyPHIvsT = 0
dataReadyDELAYvsT = 0
dataReadyFTOFFSETSvsT = 0
dataReadyFTSTATEvsT = 0
dataReadyFTNUMvsFTOFFSETS = 0
dataReadyPHIvsOPD = 0
dataReadyFTNUMvsT = 0

FLUXvsTArr = np.zeros((MAXCOMBOS, FTMEMORY), dtype=np.float32)
FLUXvsTArrScanNrLast = 0
FLUXvsTArrScanNrNew = 0

FLUXvsOPDArr = np.zeros((MAXCOMBOS, numberOfFrames), dtype=np.float32)
PHIvsOPDArr = np.zeros((MAXCOMBOS/2, numberOfFrames), dtype=np.float64)
AMPvsOPDArrOPD = np.zeros((MAXCOMBOS, numberOfFrames), dtype=np.float32)
AMPvsOPDArrAMP = np.zeros((MAXCOMBOS, numberOfFrames), dtype=np.float32)  
AMPvsOPDArrFIT = np.zeros((MAXCOMBOS, numberOfFrames), dtype=np.float32)


AMPvsOPDArrDelays = np.zeros((MAXCOMBOS/2,2), dtype=np.float32)
PHIvsTArr = np.zeros((MAXCOMBOS / 2, FTMEMORY), dtype=np.float32)
PHIvsTArrScanNrLast = 0
PHIvsTArrScanNrNew = 0

FTOFFSETSvsTArr = np.zeros((MAXCOMBOS / 2, 5 * FTMEMORY), dtype=np.float32)
FTOFFSETSvsTArrScanNrLast = 0
FTOFFSETSvsTArrScanNrNew = 0

DELAYvsTArr = np.zeros((MAXCOMBOS / 2, 2 * FTMEMORY), dtype=np.float32)
DELAYvsTArrScanNrLast = 0
DELAYvsTArrScanNrNew = 0

FTNUMvsTArr = np.zeros((MAXCOMBOS / 2, 5 * FTMEMORY), dtype=np.float32)
FTNUMvsTArrScanNrLast = 0
FTNUMvsTArrScanNrNew = 0

FTNUMvsFTOFFSETSArrScanNrLast = 0
FTNUMvsFTOFFSETSArrScanNrNew = 0

tel1Entry = {}
tel2Entry = {}


